<template>
    <div id="app">
        <transition name="fade" v-if="isLoading">
            <pulse-loader></pulse-loader>
        </transition>
        <transition name="fade" v-if="!isLoading">
            <div>
                <select id="voices" v-model="selectedVoice">
                    <option v-for="(voice, index) in voiceList" v-bind:key="index" :data-lang="voice.lang"
                            :value="index">
                        {{ voice.name }} ({{ voice.lang }})
                    </option>
                </select>
                <p ref="target" @mouseup="reading($event)">
                    Ay, ay, ay, ay, canta y no llores
                    Porque cantando se alegran
                    Cielito lindo los corazones

                    De la sierra, morena
                    Cielito lindo vienen bajando
                    Un par de ojitos negros
                    Cielito lindo de contrabando

                    De la sierra, morena
                    Cielito lindo vienen bajando
                    Un par de ojitos negros
                    Cielito lindo de contrabando

                    Ay, ay, ay, ay, canta y no llores
                    Porque cantando se alegran
                    Cielito lindo los corazones

                    Ay, ay, ay, ay, canta y no llores

                    Porque cantando se alegran
                    Cielito lindo los corazones

                    Ese lunar que tienes, cielito lindo
                    Junto a la boca, no se lo des a nadie
                    Cielito lindo que a mi me toca

                    Ese lunar que tienes,…
                </p>
            </div>
        </transition>
    </div>
</template>

<script>

    import PulseLoader from 'vue-spinner/src/PulseLoader.vue'

    export default {
        name: 'App',
        components: {
            PulseLoader
        },
        data: () => {
            return {
                synth: window.speechSynthesis,
                voiceList: [],
                speech: new window.SpeechSynthesisUtterance(),
                selectedVoice: 0,
                isLoading: true
            }
        },
        async mounted() {
            this.voiceList = await this.synth.getVoices();

            if (this.voiceList.length) {
                this.isLoading = false
            }

            this.synth.onvoiceschanged = () => {
                this.voiceList = this.synth.getVoices()

                setTimeout(() => {
                    this.isLoading = false
                }, 800)
            }

        },
        methods: {
            reading($event) {
                const readed = $event.view.getSelection().toString();

                if (readed === null || readed === '') {
                    return;
                }
                this.speech.text = readed;
                this.speech.voice = this.voiceList[this.selectedVoice];
                this.synth.speak(this.speech);
            }
        }
    }
</script>

<style>
    #app {
        font-family: Avenir, Helvetica, Arial, sans-serif;
        -webkit-font-smoothing: antialiased;
        -moz-osx-font-smoothing: grayscale;
        text-align: center;
        color: #2c3e50;
        margin-top: 60px;
    }

    .v-spinner {
        position: fixed;
        display: flex;
        align-items: center;
        justify-content: center;
        z-index: 1;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        background: rgba(255, 255, 255, 0.8);
        -webkit-backdrop-filter: blur(4px);
        backdrop-filter: blur(4px);
    }

    .fade-enter-active, .fade-leave-active {
        transition: opacity ease .5s;
    }

    .fade-enter, .fade-leave-to {
        opacity: 0;
    }
</style>
